script.on_event(
	defines.events.on_tick, 
	function(event)
		if (
			type(global.chests) == "table" and
			#global.chests > 0 and
			event.tick % settings.global["wb-blueprint-request-chest-tick-every"].value == 0
		) then
			--game.print(tick_every);
			for index, chest in pairs(global.chests) do
				if chest.valid then
					tickChest(chest)
				else
					table.remove(global.chests, index)
				end
			end
		end
	end
)

script.on_event({
    defines.events.on_built_entity,
    defines.events.on_robot_built_entity
},
    function(event)
		if event.created_entity.name == "wb-blueprint-chest" then
			if global.chests == nil then
				global.chests = {}
			end
			table.insert(global.chests, event.created_entity)
        end
	end
)

function DefinedNeededItems(blueprint)
	local copy = {}
	for name, count in pairs(blueprint.cost_to_build) do
		table.insert(copy, {name = name, count = count})
	end
	return copy
end

function addSignal(behavior, signal)
	for i=1, behavior.signals_count do
		local sig = behavior.get_signal(i);
		if(sig and sig.signal)then
			if(sig.signal.name and sig.signal.name == signal.name)then
				behavior.set_signal(i, {
					count = sig.count + signal.count,
					signal = {
						type = "item", 
						name = signal.name
					}
				})
				return
			end
		else
			-- This is end
			behavior.set_signal(i, { 
				count = signal.count, 
				signal = { 
					type = "item", 
					name = signal.name
				}
			})
			return
		end
	end
end

function tickChest(e)
	local behavior = e.get_or_create_control_behavior()
	behavior.parameters = { parameters = {}}

	if(not behavior.enabled) then return end

	local containers = e.surface.find_entities_filtered({
		area = { { e.position.x - 1, e.position.y - 1 }, { e.position.x + 1, e.position.y + 1 } },
		type = {"logistic-container", "container"},
		force = e.force,
	})
	for i_container, c in pairs(containers) do
		local inventory = c.get_inventory(defines.inventory.chest)
	if(inventory and inventory.valid and not inventory.is_empty()) then
			for i_inventory = 1, #inventory do
				local stack = inventory[i_inventory]
				if(stack and stack.valid_for_read and stack.type == "blueprint") then
					local needed = DefinedNeededItems(stack)
					for i_need = 1, #needed do
						addSignal(behavior, needed[i_need])
					end
				end
			end
		end
	end
end