data:extend {
    {
        type = "item",
        name = "wb-blueprint-chest",
        icon = "__blueprint_request_chest_revamp__/graphics/icon.png",
		icon_size = 32,
        subgroup = "logistic-network",
        order = "b[storage]-c[logistic-chest-requester]",
        place_result = "wb-blueprint-chest",
        stack_size = 50
	}
}

data:extend {
	{
        type = "recipe",
        name = "wb-blueprint-chest",
        enabled = true,
        ingredients =
        {
            {"steel-chest", 1},
			{"electronic-circuit", 3},
			{"advanced-circuit", 1}
        },
        result = "wb-blueprint-chest"
    }
}

if data.raw.technology["circuit-network"] then
	if not data.raw.technology["circuit-network"].effects then data.raw.technology["circuit-network"].effects = {} end

	table.insert(data.raw.technology["circuit-network"].effects, 
		{
			type = "unlock-recipe",
			recipe = "wb-blueprint-chest"
		}
	)
end

local deployer = table.deepcopy(data.raw["constant-combinator"]["constant-combinator"])
deployer.name = "wb-blueprint-chest"
deployer.type = "constant-combinator"
deployer.icon = "__blueprint_request_chest_revamp__/graphics/icon.png"
deployer.icon_size = 32
deployer.item_slot_count = 666
deployer.minable = { hardness = 0.2, mining_time = 0.5, result = "wb-blueprint-chest" }

--energy inherits by combinator but constant combinator is not a combinator
--deployer.energy_source = data.raw["arithmetic-combinator"]["arithmetic-combinator"].energy_source
--deployer.active_energy_usage = data.raw["arithmetic-combinator"]["arithmetic-combinator"].active_energy_usage

deployer.sprites = make_4way_animation_from_spritesheet({ layers = {
	{
		filename = "__blueprint_request_chest_revamp__/graphics/norm.png",
		width = 58,
		height = 52,
		frame_count = 1,
		shift = util.by_pixel(0, 5),
		hr_version = {
			scale = 0.5,
			filename = "__blueprint_request_chest_revamp__/graphics/hr.png",
			width = 114,
			height = 102,
			frame_count = 1,
			shift = util.by_pixel(0, 5)
		}
	},
	{
		filename = "__blueprint_request_chest_revamp__/graphics/shadow.png",
		width = 50,
		height = 34,
		frame_count = 1,
		shift = util.by_pixel(9, 6),
		draw_as_shadow = true,
		hr_version = {
			scale = 0.5,
			filename = "__blueprint_request_chest_revamp__/graphics/hr-shadow.png",
			width = 98,
			height = 66,
			frame_count = 1,
			shift = util.by_pixel(8.5, 5.5),
			draw_as_shadow = true
		}
	}
}})
data:extend{deployer}